#ifndef M_CLASSBUILDER_H
#define M_CLASSBUILDER_H

#include "mString.h"
#include "mDefs.h"
#include "mList.h"
#include "mMethod.h"
#include "mVariable.h"
#include <iostream>
#include "mLiteral.h"
#include "mCode.h"
#include "mMethodTable.h"


class mMethod;
class mParseTree;



// class
class mClassBuilder{
      public:
             // creates new classbuilder with specified environment
             mClassBuilder(mEnvironment*);

             virtual ~mClassBuilder();
             
             // adds class. returns 0 on success, 1 if file could not be opened
             int addClass(mString*);

      private:
             mEnvironment*  environment;
     
             
};


#endif
