#ifndef MCLASSDUMPER_H
#define MCLASSDUMPER_H

#include "mString.h"
#include "mDefs.h"
#include "mList.h"
#include "mMethod.h"
#include "mVariable.h"
#include "mLiteral.h"
#include <iostream>

class mClassDumper{
      public:
             mClassDumper(mClass*);

             ~mClassDumper();

             //void setLiteralList(mList<mSymbol>*);

             // dumps class
             void dump();
             
      private:

	     // dump virtual table for all classes in hierarchy
	     void dumpVirtualTable(mMethodTable*, FILE*);

	     // dump method table for all classes in hierarchy
	     void dumpMethodTable(mMethodTable*, FILE*);

	     // dump object table for all classes in hierarchy
	     void dumpObjectTable(mMethodTable*, FILE*);



	     // dumps closure and all its children
	     // returns size of code dumped
	     int dumpClosure(mEnvironment*, FILE*);

	     mClass *theClass;
            
};

#endif
