
#include "mMethodClass.h"


mMethodClass::mMethodClass(mClass* genericMethod, mClass* super, mList<mClass>* parameters, mClass* returnType)
  : mClass( )
{  

  // build classname
  name = new mString( getTypeName(parameters, returnType) );

  // this is special method type
  isMethodType = true;

  // create parameter list
  this->parameters = new mList<mClass>();
  

  // superclass of special method class is Object
  addSuperClass( super );
  


  // add all methods from generic Method class
  //TUKAJ


  if(parameters)
    for(mClass* param = parameters->first(); param != 0; param = parameters->next())
      this->parameters->append( param );      

  this->returnType = returnType;

}


mMethodClass::mMethodClass(mClass* genericMethod, mClass* super, mList<mParameter>* parameters, mClass* returnType)
  : mClass( )
{  

  // build classname
  name = new mString( getTypeName(parameters, returnType) );

  // this is special method type
  isMethodType = true;

  // create parameter list
  this->parameters = new mList<mClass>();

  // superclass of special method class is Object
  addSuperClass( super );
  


  // add all methods from generic Method class
  //TUKAJ


  // add parameter types and return type
  if(parameters)
    for(mParameter* param = parameters->first(); param != 0; param = parameters->next())
      this->parameters->append( param->theClass );     


  this->returnType = returnType;

}



mMethodClass::~mMethodClass()
{

  delete parameters;

}


mString mMethodClass::getTypeName(mList<mClass>* parameters, mClass* returnType)
{

  mString mname("Method");
 
  if(parameters){


    unsigned i = 0;
    mname += '(';
    for(mClass* param = parameters->first(); param != 0; param = parameters->next(), i++){
      mname += *param->name;
      if(i < parameters->size() - 1)
	mname += ' ';
    }

    mname += ')';
  
    if(returnType)
      mname += ": " + *returnType->name;

  }

  // build classname
  return mname;

}



mString mMethodClass::getTypeName(mList<mParameter>* parameters, mClass* returnType)
{

  mString mname("Method");
 
  if(parameters){


    unsigned i = 0;
    mname += '(';
    for(mParameter* param = parameters->first(); param != 0; param = parameters->next(), i++){
      mname += *param->theClass->name;
      if(i < parameters->size() - 1)
	mname += ' ';
    }

    mname += ')';
  
    if(returnType)
      mname += ": " + *returnType->name;

  }

  // build classname
  return mname;

}
