#ifndef __MLINKENTRY_H
#define __MLINKENTRY_H

#include "mString.h"
#include "mDefs.h"

// link entry represents link addresses for one external class
class mLinkEntry{
      public:
             // creates new entry for class with specified name
             mLinkEntry(mString& cname, int n, int* off){
                name = new mString(cname);
		nOffsets = n;
		offsets = off;
		classAddress = 0;
             }	     

             virtual ~mLinkEntry(){ 
	       delete name; 
	       delete[] offsets;
	     }

             mString* name;     // name of the class
	     int* offsets;
	     int nOffsets;
	     int classAddress;  // address of classdata for class of this link entry
};


#endif
