#include "mVirtualMachine.h"


int main(int argc, char** argv)
{
 
  if(argc < 2){
     cout<<"no class file"<<endl;
     return 1;
  }


  // check if home dir has been set
  if( getenv("ZHOME") == NULL){
    
    cout<<"$ZHOME environment variable must be set"<<endl;
    return 1;    
  }


  // create new instance of virtual machine
  mVirtualMachine *vm = new mVirtualMachine( argv );


  // load our class
  mLoadedClass* theClass = vm->loadLocalClass( new mString(argv[1]) );

  if( theClass )
    vm->executeClass( theClass );


  delete vm;
  return 0;
}
