#ifndef MSYMBOL_H
#define MSYMBOL_H

#include "mDefs.h"

class mClass;

class mSymbol{
      public:
             // creates variable symbol
             mSymbol();

             virtual ~mSymbol();

             // returns string representation of this symbol
	     virtual mString toString()=0;

	     // returns true if identifier symbol is valid. invalid identifiers are:
	     //     - self
	     //     - ...?
	     static bool isValid(mString* name){
	       return ( *name != "self" );
	     }

	     //protected:      
             short symbolType;    // type (SYMBOL_VARIABLE, ...)
             mString *name;       // name of this symbol
	     
             mClass  *theClass; // the class of this symbol
	     
	     // this is set to true if a parent symbol is used in child environment	     
	     bool used;


             
};

#endif

