#ifndef M_UTIL_H
#define M_UTIL_H

#include "mString.h"
#include "mList.h"
#include "mClass.h"


class mUtil{
      public:
             // returns true if file is a valid source class file (name.z0)
             static bool fileNameValid(mString*);

             // extracts class name from file name (i.e. myClass.z0 returns myClass)
             static mString classNameFromFile(mString*);

	     // returns true if ''native' method modifier is present in a string list
             static bool hasNativeModifier(mList<mString> *);

	     // returns type from QualifiedIdentifier in environment env
             static mClass* getQualifiedType(mList<mString>*, mEnvironment*);

	     // returns fully qualified type name from QualifiedIdentifier
             static mString getQualifiedTypeName(mList<mString>*);

             
};

#endif

