#ifndef MVARIABLE_H
#define MVARIABLE_H

#include "mString.h"
#include "mSymbol.h"

class mClass;

// instance variable
class mVariable : public mSymbol{
      public:
             // name, type (class), binding, entry
             mVariable(mString*, mClass*, short, int);

             virtual ~mVariable();

             // returns string representation of this variable
             virtual mString toString();

             int     value;
             double  dvalue;
             short   bind;
             int     entry;       // stack entry
};

#include "mClass.h"

#endif

