#include "shared.h"
#include "nativeInterface.h"


// returns ptr to metadata inside object
int* getMetaAddress(int* object)
{
  // object Class contains classdata as value after method table
  int *classData = (int*)*(object + CLASS_OFFSET);

  // get meta size from 4th field of classinfo
  int metaSize = *(classData + 4);

  int* metaInfo = (int*)( (char*)classData - metaSize);  // ptr to start of metadata

  return metaInfo;
}


// returns ptr to metadata inside object other than Class by using OFFSET
// Method for example...
int* getMetaAddressWithOffset(int* object, int offset)
{
  // object contains classdata as value after method table
  int *classData = (int*)*(object + offset);

  // get meta size from 4th field of classinfo
  int metaSize = *(classData + 4);

  int* metaInfo = (int*)( (char*)classData - metaSize);  // ptr to start of metadata

  return metaInfo;
}




// returns ptr to metadata inside object
int* getMetaAddressFromClassData(int* classData)
{

  // get meta size from 4th field of classinfo
  int metaSize = *(classData + 4);

  int* metaInfo = (int*)( (char*)classData - metaSize);  // ptr to start of metadata

  return metaInfo;
}
