#ifndef YYERRCODE
#define YYERRCODE 256
#endif

#define CATEGORY 257
#define USE 258
#define CLASS 259
#define FIELD 260
#define METHOD 261
#define IS 262
#define INHERITS 263
#define IMPLEMENTS 264
#define PUBLIC 265
#define PRIVATE 266
#define PROTECTED 267
#define RESTRICTED 268
#define NATIVE 269
#define STATIC 270
#define CONSTRUCTOR 271
#define DESTRUCTOR 272
#define THIS 273
#define SUPER 274
#define AS 275
#define RETURN 276
#define WHILE 277
#define DO 278
#define IF 279
#define THEN 280
#define ELSE 281
#define FOR 282
#define BYTE 283
#define CHAR 284
#define SHORT 285
#define INT 286
#define LONG 287
#define FLOAT 288
#define DOUBLE 289
#define STRING 290
#define VOID 291
#define BOOLEAN 292
#define SELF 293
#define TRUE 294
#define FALSE 295
#define NIL 296
#define NEW 297
#define METHODTYPE 298
#define OP_EQ 299
#define OP_NOT_EQ 300
#define OP_GREATER_OR_EQ 301
#define OP_LESS_OR_EQ 302
#define OP_AND 303
#define OP_OR 304
#define OP_METHODASSIGN 305
#define OP_ADDASSIGN 306
#define OP_DECASSIGN 307
#define OP_MULASSIGN 308
#define OP_DIVASSIGN 309
#define OP_INCREMENT 310
#define OP_DECREMENT 311
#define INTEGER_LITERAL 312
#define DOUBLE_LITERAL 313
#define STRING_LITERAL 314
#define IDENTIFIER 315
typedef union{
  int                      intVal;
  double                   doubleVal;
  mString*                 stringVal;
  mList<mString>*          stringList;
  mClass*                  classVal;
  /*mField*                  fieldVal;*/
  /*mList<mField>*           fieldListVal;*/
  /*mMethod*                 methodVal;*/
  mVariable*               variableVal;
  mLiteral*                literalVal;
  mCode*                   codeVal;
  mParseTree*              treeVal;
  mList<mClassExtension>*  extensionList;
  mList<mClass>*           classList;
  /*mParameter*              parameterVal;*/
  mList<mParameter>*       parameterListVal;
  /*mLocalDefinition*        localDefinitionVal;*/
  /*mList<mLocalDefinition>* localDefinitionListVal;*/
  /*mSymbol*                 symbolVal;*/
/*  mEnvironment*            environmentVal;*/

} YYSTYPE;
extern YYSTYPE yylval;
